<script type="text/x-template" id="t-mg-carousel-{$elementId|strtolower}"
        :component_id="component_id"
        :component_namespace="component_namespace"
        :component_index="component_index"
>
    <div id="mgSlider" class="mgSlider" v-show="areItems">
        <div class="lu-row lu-row--eq-height">
            <div class="lu-col-lg-12">
                <div id="cart-first-step-content" data-type="_tile">
                    <div class="lu-widget__header">
                        <h2 class="lu-h5">{$MGLANG->translate({$rawObject->getTitle()})}</h2>
                    </div>
                    <div class="widget-slider-container">
                        <div class="widget-slider-loader hidden"><i class="spinner"></i></div>
                        <div class="lSSlideOuter ">
                            <div class="lSSlideWrapper usingCss" style="transition-duration: 400ms; transition-timing-function: ease;">
                                <div class="row widget-slider lightSlider lSSlide lsGrab">
                                    <div class="col-lg-4 col-sm-6 col-xs-6 additional-product-widget lslide slide-active"
                                         @mouseenter="slideInfoShow" @mouseleave="slideInfoHide"
                                         v-for="(item, index) in items">
                                        <div class="widget w-short product-widget-tile">
                                            {literal}
                                                <div class="widget-header">
                                                    <div class="header-title"
                                                         :style="{backgroundColor: item.backgroundColor}">

                                                        <div class="title-icon">
                                                            <span></span>
                                                            <img :src="item.image" :alt="item.name"></div>
                                                    </div>
                                                    <div class="header-label">
                                                        <div class="label label-8  label-long" v-if="item.price.discount">
                                                            <b>-{{item.price.discount}}</b>{/literal}{$MGLANG->absoluteTranslate("price","discount")}{literal}
                                                        </div>
                                                    </div>
                                                </div>
                                                <div class="widget-body">
                                                    <h3 class="lu-m-b-2x" v-html="item.name"></h3>
                                                    <div class="info">
                                                        <div class="info-content">
                                                            <p v-html="item.tag"></p>
                                                        </div>
                                                    </div>
                                                </div>
                                                <div class="price  price-discounted" v-if="item.price.newPrice">
                                                    <span class="price-line price-discount">{{item.price.regularPrice}}</span>
                                                    <b class="price-line price-final">{{item.price.newPrice}}</b>{{item.price.cycle}}
                                                </div>
                                                <div class="price  price-discounted" v-else>
                                                    <b class="price-line price-final">{{item.price.regularPrice}}</b>{{item.price.cycle}}
                                                </div>
                                                <div class="widget-actions">
                                                    <button class="btn btn-xs btn-success btn-icon cart-order-product product-add-to-cart"
                                                       @click="addToCart(item.id, $event)">
                                                        <span><i class="lu-zmdi lu-zmdi-shopping-cart"></i></span>
                                                        <span class="button-loader hidden"><i
                                                                    class="spinner"></i></span>
                                                        <div class="check-animate hidden"></div>
                                                    </button>
                                                </div>
                                            {/literal}
                                        </div>
                                    </div>
                                </div>
                                <div class="lSAction">
                                    <a class="lSPrev" v-show="moveArrow" :disabled="isAnimate" @click="moveCarousel(1, $event)" ><i class="lu-zmdi lu-zmdi-arrow-left"></i></a>
                                    <a class="lSNext" v-show="moveArrow" :disabled="isAnimate" @click="moveCarousel(-1, $event)" ><i class="lu-zmdi lu-zmdi-arrow-right"></i></a>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="lu-preloader-container lu-preloader-container--full-screen lu-preloader-container--overlay"
                         v-show="loading_state">
                        <div class="lu-preloader lu-preloader--sm"></div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</script>



